// This file was generated by Dashcode from Apple Computer, Inc.
// You may edit this file to customize your Dashboard widget.

// Properties set by attributes panel
var updateInterval;

// Monitor objects
var pqMonitor;
var monitorsRunning;

// Flush queue system call object
var flusher;
var flusherMonitor;

function load()
{
	setupParts();

	// Get the properties
	updateInterval = +attributes.updateInterval;
	if (!updateInterval) {
		updateInterval = 1;
	}
	
	initMonitors();
}

// Set the contents of an HTML div
function setElementText(elementName, elementValue)
{
	var element = document.getElementById(elementName);
	if (element) {
		element.innerText = elementValue;
	}
	else {
		alert("Can't find element with name: " + elementName);
	}
}

function initMonitors()
{
	//setElementText("text-queuesize", "--");
	pqMonitor = new PostqueueMonitor(updateInterval);
	pqMonitor.ioCallback = function (value) { setElementText("text-queuesize", value); };
	pqMonitor.start();
	
	monitorsRunning = true;
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
	if (monitorsRunning) {
		pqMonitor.stop();
		monitorsRunning = false;
	}
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
	if (monitorsRunning === false) {
		pqMonitor.start();
		monitorsRunning = true;
	}
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function flushQueue(event)
{
	// clear out last command
	if (flusher != null) {
		flusher.cancel();
		delete flusher;
	}
	// get a return function
	var onFinished = function (command) {
		// do nothing
	};
	// set system command
	flusher = widget.system("/usr/sbin/postqueue -f", onFinished);
	// update right now
	if (flusherMonitor != null) {
		flusherMonitor.stop();
		delete flusherMonitor;
	}
	flusherMonitor = new PostqueueMonitor(updateInterval);
	flusherMonitor.ioCallback = function (value) { setElementText("text-queuesize", value); flusherMonitor.stop(); };
	flusherMonitor.start();
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}


function visitSite(event) 
{
	if (window.widget)
		widget.openURL ("http://www.joshjacob.com");
	else 
		document.location = "http://www.joshjacob.com";
}


function visitSiteOver(event) 
{
	document.body.style.cursor = 'hand';
}


function visitSiteOut(event) 
{
	document.body.style.cursor = 'default';
}


function refresh(event) 
{
	// update right now
	if (flusherMonitor != null) {
		flusherMonitor.stop();
		delete flusherMonitor;
	}
	flusherMonitor = new PostqueueMonitor(updateInterval);
	flusherMonitor.ioCallback = function (value) { setElementText("text-queuesize", value); flusherMonitor.stop(); };
	flusherMonitor.start();
}
